{**********************************************************}
{ This unit is a part of GBase based demonstration program.}
{**********************************************************}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, ComCtrls, ExtDlgs, Buttons, clipbrd,
  GStandContr, GExtContr, GPositioners, GSpreader, Gbase;

type
  TForm1 = class(TForm)
    GRichEdit1: TGRichEdit;
    Image1: TImage;
    GGrid1: TGGrid;
    GImgPositioner1: TGImgPositioner;
    add1: TSpeedButton;
    del1: TSpeedButton;
    OpenPictureDialog1: TOpenPictureDialog;
    GSpreader1: TGSpreader;
    Gbase2: TGbase;
    Gbase3: TGbase;
    GSpreader2: TGSpreader;
    GSpreader3: TGSpreader;
    gar1: TSpeedButton;
    gar2: TSpeedButton;
    gar3: TSpeedButton;
    SpeedButton1: TSpeedButton;
    ColorDialog1: TColorDialog;
    SpeedButton2: TSpeedButton;
    ComboBox1: TComboBox;
    frompicture: TSpeedButton;
    fromclip: TSpeedButton;
    packall: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label1: TLabel;
    GTool1: TGTool;
    Gbase1: TGbase;
    procedure FormCreate(Sender: TObject);
    procedure Gbase1BeforeOpen(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Gbase1Positioning(Sender: TObject;
      NewRecNo: Cardinal);
    procedure add1Click(Sender: TObject);
    procedure del1Click(Sender: TObject);
    procedure gar1Click(Sender: TObject);
    procedure gar2Click(Sender: TObject);
    procedure gar3Click(Sender: TObject);
    procedure Gbase2Positioning(Sender: TObject;
      NewRecNo: Cardinal);
    procedure Gbase3Positioning(Sender: TObject;
      NewRecNo: Cardinal);
    procedure Gbase3BeforeOpen(Sender: TObject);
    procedure Gbase2BeforeOpen(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure frompictureClick(Sender: TObject);
    procedure GGrid1Click(Sender: TObject);
    procedure fromclipClick(Sender: TObject);
    procedure Gbase1BeforeDelete(Sender: TObject; var GoDelete: Boolean);
    procedure Gbase2BeforeDelete(Sender: TObject; var GoDelete: Boolean);
    procedure Gbase3BeforeDelete(Sender: TObject; var GoDelete: Boolean);
    procedure packallClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure GTool1Record_RW(Sender: TObject);
    procedure GGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//openning databases
procedure TForm1.FormCreate(Sender: TObject);
begin
  GBase3.Open('name');
  GBase2.Open('name');
  GBase1.Open('name');
  GGrid1.SetColumnsSize([120,60]);
  GGrid1.Cells[1,0]:='  Name of a car';
  GGrid1.Cells[2,0]:='  Power';
  GGrid1.Click;
end;

//closing databases
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GBase1.Close;
  GBase2.Close;
  GBase3.Close;
end;

//setting main parameters for controls ....................
procedure TForm1.Gbase1BeforeOpen(Sender: TObject);
begin
  GGrid1.DataSource:=GBase1;
  GRichEdit1.DataSource:=GBase1;
  GImgPositioner1.DataSource:=GBase1;
  GGrid1.SetColumnsOrder([0,1], false);
  GSpreader1.AddStdReceivers([],[],[GGrid1],[]);
  GSpreader1.AddExtReceivers([],[GRichEdit1]);
end;
procedure TForm1.Gbase2BeforeOpen(Sender: TObject);
begin
  GGrid1.DataSource:=GBase2;
  GRichEdit1.DataSource:=GBase2;
  GImgPositioner1.DataSource:=GBase2;
  GGrid1.SetColumnsOrder([0,1], false);
  GSpreader2.AddStdReceivers([],[],[GGrid1],[]);
  GSpreader2.AddExtReceivers([],[GRichEdit1]);
end;
procedure TForm1.Gbase3BeforeOpen(Sender: TObject);
begin
  GGrid1.DataSource:=GBase3;
  GRichEdit1.DataSource:=GBase3;
  GImgPositioner1.DataSource:=GBase3;
  GGrid1.SetColumnsOrder([0,1], false);
  GSpreader3.AddStdReceivers([],[],[GGrid1],[]);
  GSpreader3.AddExtReceivers([],[GRichEdit1]);
end;

//sending messages about current record changing   ..........
procedure TForm1.Gbase1Positioning(Sender: TObject;
  NewRecNo: Cardinal);
begin
  GSpreader1.Spread(NewRecNo);
end;
procedure TForm1.Gbase2Positioning(Sender: TObject;
  NewRecNo: Cardinal);
begin
  GSpreader2.Spread(NewRecNo);
end;
procedure TForm1.Gbase3Positioning(Sender: TObject;
  NewRecNo: Cardinal);
begin
  GSpreader3.Spread(NewRecNo);
end;

//adding record   .............................................
procedure TForm1.add1Click(Sender: TObject);
begin
  if GGrid1.DataSource=GBase1 then
    GBase1.Append;
  if GGrid1.DataSource=GBase2 then
    GBase2.Append;
  if GGrid1.DataSource=GBase3 then
    GBase3.Append;
end;

//deleting current record   .................................
procedure TForm1.del1Click(Sender: TObject);
begin
  if GGrid1.DataSource=GBase1 then
    GBase1.Delete;
  if GGrid1.DataSource=GBase2 then
    GBase2.Delete;
  if GGrid1.DataSource=GBase3 then
    GBase3.Delete;
end;

//choose garage   ...........................................
procedure TForm1.gar1Click(Sender: TObject);
begin
  GGrid1.DataSource:=GBase1;
  GRichEdit1.DataSource:=GBase1;
  GImgPositioner1.DataSource:=GBase1;
  GGrid1.Row:=1;
  GGrid1.Click;
end;
procedure TForm1.gar2Click(Sender: TObject);
begin
  GGrid1.DataSource:=GBase2;
  GRichEdit1.DataSource:=GBase2;
  GImgPositioner1.DataSource:=GBase2;
  GGrid1.Row:=1;
  GGrid1.Click;
end;
procedure TForm1.gar3Click(Sender: TObject);
begin
  GGrid1.DataSource:=GBase3;
  GRichEdit1.DataSource:=GBase3;
  GImgPositioner1.DataSource:=GBase3;
  GGrid1.Row:=1;
  GGrid1.Click;
end;

//changing text style   ......................................
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if fsbold in GRichEdit1.SelAttributes.Style then
    GRichEdit1.SelAttributes.Style:=GRichEdit1.SelAttributes.Style-[fsbold]
  else
    GRichEdit1.SelAttributes.Style:=GRichEdit1.SelAttributes.Style+[fsbold];
end;

//changing color   ...........................................
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if colordialog1.Execute then
    GRichEdit1.SelAttributes.Color:=colordialog1.Color;
end;

//changing text size   .......................................
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  GRichEdit1.SelAttributes.Size:=strtoint(combobox1.Text);
end;

//Load bitamp from database to image
procedure TForm1.GGrid1Click(Sender: TObject);
var bmp: TBitmap;
begin
  bmp:=TBitmap.Create;
  try
    if GGrid1.DataSource=GBase1 then
      GBase1.ReadBmp('foto',bmp);
    if GGrid1.DataSource=GBase2 then
      GBase2.ReadBmp('foto',bmp);
    if GGrid1.DataSource=GBase3 then
      GBase3.ReadBmp('foto',bmp);
    image1.Picture.Bitmap.Assign(bmp);
    image1.Repaint;
  finally
    bmp.Free;
  end;
end;

//write bitmap from picture to database
procedure TForm1.frompictureClick(Sender: TObject);
var bmp: TBitmap;
begin
  if openpicturedialog1.Execute then
  begin
    image1.Picture.Bitmap.LoadFromFile(OpenPictureDialog1.FileName);
    bmp:=TBitmap.Create;
    try
      bmp.Assign(image1.Picture.Bitmap);
      if GGrid1.DataSource=GBase1 then
        GBase1.WriteBmp('foto',bmp);
      if GGrid1.DataSource=GBase2 then
        GBase2.WriteBmp('foto',bmp);
      if GGrid1.DataSource=GBase3 then
        GBase3.WriteBmp('foto',bmp);
    finally
      bmp.Free;
    end;
  end;
end;

//write bitmap from clipboard to database
procedure TForm1.fromclipClick(Sender: TObject);
var bmp: TBitmap;
begin
  if not Clipboard.HasFormat(CF_BITMAP) then
  begin
    showmessage('There is no bitmap in clipboard');
    exit;
  end;
  image1.Picture.Bitmap.Assign(Clipboard);
  if MessageDlg('Copy this picture to database now?',mtConfirmation, [mbYes, mbNo], 0) = mrNo then
  begin
    image1.Picture.Assign(nil);
    exit;
  end;
  bmp:=TBitmap.Create;
  try
    bmp.Assign(image1.Picture.Bitmap);
    if GGrid1.DataSource=GBase1 then
      GBase1.WriteBmp('foto',bmp);
    if GGrid1.DataSource=GBase2 then
      GBase2.WriteBmp('foto',bmp);
    if GGrid1.DataSource=GBase3 then
      GBase3.WriteBmp('foto',bmp);
  finally
    bmp.Free;
  end;
end;

//make sure before delete
procedure TForm1.Gbase1BeforeDelete(Sender: TObject; var GoDelete: Boolean);
begin
  if MessageDlg('Really delete ?',mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    GoDelete:=false;
end;
procedure TForm1.Gbase2BeforeDelete(Sender: TObject; var GoDelete: Boolean);
begin
  if MessageDlg('Really delete ?',mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    GoDelete:=false;
end;
procedure TForm1.Gbase3BeforeDelete(Sender: TObject; var GoDelete: Boolean);
begin
  if MessageDlg('Really delete ?',mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    GoDelete:=false;
end;

//Packing databases
procedure TForm1.packallClick(Sender: TObject);
begin
  if MessageDlg('Pack databases now ?',mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    exit;
  gbase1.Close;
  gtool1.CopyAndPack(form1,'car1','xyz',true);
  gbase2.Close;
  gtool1.CopyAndPack(form1,'car2','xyz',true);
  gbase3.Close;
  gtool1.CopyAndPack(form1,'car3','xyz',true);
  gbase3.Open('name');
  gbase2.Open('name');
  gbase1.Open('name');
  label1.Caption:='';
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if GGrid1.DataSource=GBase1 then
    GBase1.IndexOn(GBase1.ActiveIndex,not gbase1.ascendingIndex);
  if GGrid1.DataSource=GBase2 then
    GBase2.IndexOn(GBase2.ActiveIndex,not gbase2.ascendingIndex);
  if GGrid1.DataSource=GBase3 then
    GBase3.IndexOn(GBase3.ActiveIndex,not gbase3.ascendingIndex);
end;

procedure TForm1.GTool1Record_RW(Sender: TObject);
begin
  Label1.Caption:=inttostr(GTool1.PackedRecord);
  Label1.Repaint;
end;

procedure TForm1.GGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ggrid1.Selection;
end;

end.
